#include<bits/stdc++.h>
using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int m, x, y, vxmx, vxmn, vymx, vymn, k1, k2, k3, k4;
    vector <pair <int, int>> v;
    vector <int> vx, vy;
    cin >> m;
    for (int i = 0; i < m; i++){
        cin >> x >> y;
        v.push_back(make_pair(x, y));
    }
    cout << 0 << "\n";
    vxmx = v[0].first;
    vxmn = v[0].first;
    vymx = v[0].second;
    vymn = v[0].second;
    for (int i = 1; i < m; i++){
            vxmx = max(vxmx, v[i].first);
            vxmn = min(vxmn, v[i].first);
            vymx = max(vymx, v[i].second);
            vymn = min(vymn, v[i].second);
            for (int j = 0; j <= i; j++){
                if (j == 0){
                    k1 = 0;
                    k2 = 0;
                    k3 = 0;
                    k4 = 0;
                }
                k1 += abs(v[j].first - vxmx) * abs(v[j].second - vymx);
                k2 += abs(v[j].first - vxmx) * abs(v[j].second - vymn);
                k3 += abs(v[j].first - vxmn) * abs(v[j].second - vymx);
                k4 += abs(v[j].first - vxmn) * abs(v[j].second - vymn);
            }
            cout << max(max(k1, k2), max(k3, k4)) << "\n";
    }
    return 0;
}